﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace KlasLajbrari
{
    public delegate void NekiEvent();

    public class DnevniProgram
    {
        private DateTime datum;
        private int maxFilmova;
        public List<Film> listaFilmova;

        #region Events

        public event NekiEvent dogadjaj;

        protected void OnDogadjaj(Zanr zanr)
        {
            if (dogadjaj != null)
                dogadjaj();
        }

        #endregion
        public DnevniProgram(DateTime datum, int maxFilmova)
        {
            this.datum = datum;
            this.maxFilmova = maxFilmova;
            listaFilmova = new List<Film>();
        }

        public DnevniProgram()
        {
            // TODO: Complete member initialization
        }

        public String DajPodatke()
        {
            int trajanje = 0;
            foreach (Film film in listaFilmova)
                trajanje += film.Duzina;
            String rezultat = String.Format("{0}, traju ukupno {1}\n",datum,trajanje);

            List<Zanr> zanrovi = new List<Zanr>();
            foreach (Film film in listaFilmova)
            {
                if (!zanrovi.Contains(film.Zanr))
                    zanrovi.Add(film.Zanr);
            }

            foreach (Zanr zanr in zanrovi)
            {
                rezultat = String.Format("{0}{1}\n", rezultat, zanr.DajPodatke());
                foreach (Film film in listaFilmova)
                {
                    if (film.Zanr.DajPodatke() == zanr.DajPodatke())
                    {
                        rezultat = String.Format("{0}{1}\n", rezultat, film.DajPodatke());
                    }
                }
            }
            return rezultat;
        }

        public void DodajFilm(Film film)
        {
            if (listaFilmova.Count() == maxFilmova)
                return;

            Zanr dodatiZanr = film.Zanr;
            int broj = 0;
            foreach (Film temp in listaFilmova)
            {
                if (temp.Zanr.DajPodatke() == dodatiZanr.DajPodatke())
                    broj++;
            }
            if (broj > 3)
                return;
            if (dogadjaj != null)
            {
                Console.WriteLine("RADI!");
                dogadjaj();
            }
            listaFilmova.Add(film);
        }

        
    }
}
