﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Klase
{
    public class Kamp
    {
        string lokacija;
        int kapacitet;
        List<Gost> spisakGostiju;

        public string Lokacija
        {
            get { return lokacija; }
            set { lokacija = value; }
        }
        public int Kapacitet
        {
            get { return kapacitet; }
            set { kapacitet = value; }
        }
        public List<Gost> SpisakGostiju
        {
            get { return spisakGostiju; }
        }

        public Kamp(string l, int k)
        {
            lokacija = l;
            kapacitet = k;
            spisakGostiju = new List<Gost>();
        }

        public string DajPodatke()
        {
            string podaci = (lokacija.Length < 3) ? lokacija : lokacija.Substring(0, 3);
            foreach (Gost g in spisakGostiju)
                podaci = string.Format("{0}\n {1}", podaci, g.DajPodatke());
            return podaci;
        }

        public delegate void DodatGostEventHandler();
        public static event DodatGostEventHandler DodatGost;

        public bool DodajGosta(Gost g)
        {
            if (spisakGostiju.Count < kapacitet)
            {
                spisakGostiju.Add(g);
                Obavesti();
                return true;
            }
            return false;
        }

        public void Obavesti()
        {
            if (DodatGost != null)
                DodatGost();
        }
    }
}
