﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using proj2ClassLibrary;

namespace Projekat2
{
    class Aerodrom
    {
        string nazivAerodroma;
        List<Let> spisakLetova;
        int biznisPutnici;

        public Aerodrom(string naz)
        {
            nazivAerodroma = naz;
            spisakLetova = new List<Let>();
            biznisPutnici = 0;
        }
        public string DajPodatke()
        {
            string rezultat=" ";
            string biznisPut=" ";
            foreach (Let letItem in spisakLetova)
            {
                foreach (Putnik putnikItem in letItem.ListaPutnika)
                {
                    if (putnikItem.Sediste.Klasa == Klasa.biznis)
                    {
                        biznisPut = String.Format("{0}{1}\n",biznisPut,putnikItem);
                        biznisPutnici++;
                    }
                }
                rezultat = String.Format("{0}{1}\n{2}", rezultat,letItem,biznisPut);
            }
            rezultat = String.Format("{0}{1}\n{2}", nazivAerodroma,rezultat,biznisPutnici);
            return rezultat;
        }

        public Putnik UcitajPutnika()
        {
            string ime, prezime,klasa;
            int br;

            Console.WriteLine( "unesi ime putnika" );
            ime = Console.ReadLine();

            Console.WriteLine("unesi prezime putnika");
            prezime = Console.ReadLine();

            Console.WriteLine("unesi avionsku klasu (b ili e) ");
            klasa = Console.ReadLine();

            while (true)
            {
                try
                {
                    Console.WriteLine("unesi br sedista");
                    br = Convert.ToInt32(Console.ReadLine());
                    break;
                }
                catch (Exception)
                {
                    Console.WriteLine("unesite ponovo br sedista");
                }
              
            }
            

            if (klasa.ToLower() == "b")
                return new Putnik(ime, prezime, br, Klasa.biznis);
            else return new Putnik(ime, prezime, br, Klasa.ekonomska);
        }

        public Let UcitajLet()
        {
            string relacija;
            DateTime dat;
            //Putnik _p;

            Let l;//new let
            
            Console.WriteLine("unesite relaciju leta(polaziste - odradiste)");
            relacija=Console.ReadLine();

            Console.WriteLine("unesite datum leta");
            dat =DateTime.Parse( Console.ReadLine());
            l = new Let(relacija, dat);

            l.DodatPutnik += new Delegat(l_DodatPutnik);
            while (true)
            { 
                Console.WriteLine("unesite novog putnika");
                l.DodajPutnika(UcitajPutnika());

                Console.WriteLine("ukucajte kraj za prekid");
                if (Console.ReadLine().ToLower() == "kraj") break;
                
            }
            return l;
        }

        void l_DodatPutnik(Putnik p)
        {
            List<Putnik> put=new List<Putnik>();
            
            foreach (Let letItem in spisakLetova)
            {
                foreach (Putnik putnikItem in letItem.ListaPutnika)
                {
                    put.Add(putnikItem);
                }
            }

            foreach (Putnik temp in put)
            {
                if (temp.DajPodatke() == p.DajPodatke()) return;
            }
            if (p.Sediste.Klasa == Klasa.biznis) biznisPutnici++;
          
        }

        static void Main(string[] args)
        {
            Aerodrom a;
            string naz;

            Console.WriteLine("unesite naziv aerodroma");
            naz = Console.ReadLine();

            a = new Aerodrom(naz);
            
            a.spisakLetova.Add(a.UcitajLet());
            a.spisakLetova.Add(a.UcitajLet());

            Console.WriteLine("{0}\n Br putnika u biznis kalsi:{1}", a.DajPodatke(),a.biznisPutnici); ;

            Console.ReadLine();
        }
    }
}
